int [ ] values;
int position = 0; // index of last unsorted value
int round = 1;
color [] colors;

void setup()
{
  size(600, 600);
  
  int arraySize = int(random(12, 29)); // 12-28 values to be sorted
  values = new int[arraySize];
  colors = new color[arraySize];
  
  for (int i = 0; i < arraySize; i = i + 1) // fill array
  {
    values[i] = int(random(2, 101)); // value between 2 and 100
    colors[i] = color(random(256), random(256), random(256));
  }
  
  position = arraySize - 1;
  
  frameRate(2);
}

void draw()
{
  background(0);
  
  fill(255);
  text("Selection Sort round " + round, 275, 50);
  
  for (int i = 0; i < values.length; i = i + 1)
  {
    // draw each bar, side by side
    fill(colors[i]);
    int barLength = values[i];
    
    rect(i * 20 + 20, 300, 20, -1 * barLength); // draw each bar shifted 20px
    
    if (i == position)
    {
      fill(246, 255, 5); // highlight current position in yellow
    }
    else
    {
      fill(255);
    }
    text(values[i] + "", i*20+20, 325); // display each bar's value
  }
  
  update();
} // end of draw()

void mouseClicked()
{
  update();
}

void update() //was mouseClicked()
{
  if (round < values.length)
  {
    // find largest unsorted value
    int p = indexOfLargest(values, 0, position);
    
    // Swap with last value
    int temp = values[p];
    values[p] = values[position];
    values[position] = temp;
    
    color t = colors[p];
    colors[p] = colors[position];
    colors[position] = t;
    
    // Shrink the unsorted region by 1
    position = position - 1;
    round = round + 1;
  }
}

int indexOfLargest (int [ ] list, int start, int finish)
{
  int x = start;
  
  for (int i = start; i <= finish; i = i + 1)
  {
    if (list[i] > list[x]) // found a new largest value
    {
      x = i;
    }
  }
  
  return x;
}