// Recursively draw squares with new squares at their corners

void square(int level, float width, float x, float y)
{
  if (level < 1)
  {
    return; // do nothing -- this is the base case
  }
  else
  {
    fill(random(256), random(256), random(256));
    rect(x, y, width, width);
    
    // top-left corner
    square(level-1, 0.5*width, x-0.75*width, y-0.75*width);
    
    // top-right corner
    square(level-1, 0.5*width, x+0.75*width, y-0.75*width);

    // bottom-left corner
    square(level-1, 0.5*width, x-0.75*width, y+0.75*width);
    
    // bottom-right corner
    square(level-1, 0.5*width, x+0.75*width, y+0.75*width);
  }
}

void setup()
{
  size(500, 500);
  rectMode(CENTER);
  noStroke();
  square(10, 150, 250, 250); // start in the center at 150px wide
}

void draw() {}